#ifndef lint
static char *RCSid = "$Header: edit.c,v 1.53 90/03/19 11:00:39 mr-frog Exp $";
#endif /* not lint */

/*
 * anti.c
 *
 * Take action against che
 */

#include <stdio.h>
#include <ctype.h>
#include "misc.h"
#include "player.h"
#include "var.h"
#include "xy.h"
#include "sect.h"
#include "nat.h"
#include "news.h"
#include "nsc.h"
#include "item.h"
#include "file.h"

extern int etu_per_update;
extern int sect_mob_neg_factor;
/*
 * format: anti <SECT>
 */
anti()
{
	extern	char *argp[];
	struct	sctstr sect;
	int	nsect;
	struct	nstr_sect nstr;
	int	cond[I_MAX+1];
	int	mil, che;
	int	avail_mil;
	int	amil, ache;
	int	milkilled, chekilled;
	double	odds, damil, dache;
	int	mob;

	if (!snxtsct(&nstr, player->argp[1]))
		return RET_SYN;
	prdate();
	nsect = 0;
	while (nxtsct(&nstr, &sect)) {
		if (!player->owner) continue;
		if (nsect++ == 0) pr("che--------\n");
		getvec(VT_COND, cond, (char *)&sect, EF_SECTOR);
		mil = getvar(V_MILIT, (char *)&sect, EF_SECTOR);
		che = get_che_value(cond[C_CHE]);
		avail_mil = sect.sct_mobil/2;
		if(mil <= avail_mil) avail_mil = mil;
		if(avail_mil <= 0){
			pr("No available mil or mob in sector\n");
			return RET_OK;
		}
		pr(
		"Sector mobility/Troop strength will allow %d troops engage.\n",
			avail_mil);
		amil = mil, ache = che;
		milkilled = 0, chekilled = 0;
		mob = sect.sct_mobil;
		while(amil != 0 && ache != 0 && mob > 1){
			damil = amil;
			dache = ache;
			odds = (dache * 2.0 / (damil + dache));
			mob = mob - 2;
			if(chance(odds)){
				amil = amil - 1;
				milkilled = milkilled + 1;
			}else{
				ache = ache - 1;
				chekilled = chekilled + 1;
			}
		}
		if(mil - milkilled > 0){
			sect.sct_mobil = sect.sct_mobil - chekilled - milkilled;
			putvar(V_MILIT, mil - milkilled, (char *)&sect,
				EF_SECTOR);
			putvar(V_CHE, ache, (char *)&sect, EF_SECTOR);
			putsect(&sect);
			pr("Body Count:  Military %d - Guerillas %d.\n",
				milkilled, chekilled);
			if(ache == 0){
			pr("Partisans cleared out of this sector for now.\n");
			}else{
			pr("Partisans still active in this sector.\n");
			}
		}else{
#ifdef MOB_ACCESS
			sect.sct_mobil =
				-(etu_per_update/sect_mob_neg_factor);
#else
			sect.sct_mobil = 0;
#endif /* MOB_ACCESS */
			sect.sct_loyal = sect.sct_loyal * 0.5;
			putvar(V_MILIT, ache, (char *)&sect, EF_SECTOR);
			putvar(V_CHE, 0, (char *)&sect, EF_SECTOR);
			if(sect.sct_own == sect.sct_oldown) sect.sct_oldown=0;
			sect.sct_own = sect.sct_oldown;
			putsect(&sect);
			pr(
			"Partisans take over the sector.  You blew it.\n");
			wu(0, sect.sct_oldown, 
			"Sector %s regained from Partisan activity.",
			xyas(nstr.x,nstr.y,sect.sct_oldown));
		}
	}
	pr("    %d sector%s\n", nsect, splur(nsect));
	return 0;
}
